#ifndef BOOST_STRING_CONSTANTS_HPP
#define BOOST_STRING_CONSTANTS_HPP

#include <boost/config.hpp>

namespace boost
{
namespace strings
{
namespace constants
{
BOOST_INLINE_CONSTEXPR char* empty				=	"";

BOOST_INLINE_CONSTEXPR char* True				=	"true";
BOOST_INLINE_CONSTEXPR char* False				=	"false";
BOOST_INLINE_CONSTEXPR char* indeterminate		=	"indeterminate";
BOOST_INLINE_CONSTEXPR char* overdeterminate	=	"overdeterminate";
BOOST_INLINE_CONSTEXPR char* underdeterminate	=	"underdeterminate";

BOOST_INLINE_CONSTEXPR char* absent				=	"absent";
BOOST_INLINE_CONSTEXPR char* present			=	"present";

BOOST_INLINE_CONSTEXPR char* minus				=	"minus";
BOOST_INLINE_CONSTEXPR char* plus				=	"plus";
BOOST_INLINE_CONSTEXPR char* both				=	"both";

BOOST_INLINE_CONSTEXPR char* literal_minus		=	"-";
BOOST_INLINE_CONSTEXPR char* literal_plus		=	"+";
BOOST_INLINE_CONSTEXPR char* literal_both		=	"±";

BOOST_INLINE_CONSTEXPR char* alpha				=	"alpha";
BOOST_INLINE_CONSTEXPR char* beta				=	"beta";
BOOST_INLINE_CONSTEXPR char* delta				=	"delta";
BOOST_INLINE_CONSTEXPR char* gamma				=	"gamma";

BOOST_INLINE_CONSTEXPR char* yes				=	"yes";
BOOST_INLINE_CONSTEXPR char* no					=	"no";
BOOST_INLINE_CONSTEXPR char* unknown			=	"unknown";

BOOST_INLINE_CONSTEXPR char* even				=	"even";
BOOST_INLINE_CONSTEXPR char* odd				=	"odd";
BOOST_INLINE_CONSTEXPR char* prime				=	"prime";

BOOST_INLINE_CONSTEXPR char* nan				=	"nan";
BOOST_INLINE_CONSTEXPR char* minus_nan			=	"-nan";
BOOST_INLINE_CONSTEXPR char* plus_nan			=	"+nan";

BOOST_INLINE_CONSTEXPR char* finite				=	"finite";
BOOST_INLINE_CONSTEXPR char* infinite			=	"infinite";

BOOST_INLINE_CONSTEXPR char* inf				=	"inf";
BOOST_INLINE_CONSTEXPR char* minus_inf			=	"-inf";
BOOST_INLINE_CONSTEXPR char* plus_inf			=	"+inf";

BOOST_INLINE_CONSTEXPR char* half_inf			=	"half_inf";
BOOST_INLINE_CONSTEXPR char* pos_inf			=	"pos_inf";
BOOST_INLINE_CONSTEXPR char* neg_inf			=	"neg_inf";

BOOST_INLINE_CONSTEXPR char* normal				=	"normal";
BOOST_INLINE_CONSTEXPR char* denormal			=	"denormal";
//BOOST_INLINE_CONSTEXPR char* subnormal			=	"subnormal";

BOOST_INLINE_CONSTEXPR char* exact				=	"exact";
BOOST_INLINE_CONSTEXPR char* inexact			=	"inexact";

BOOST_INLINE_CONSTEXPR char* valid				=	"valid";
BOOST_INLINE_CONSTEXPR char* invalid			=	"invalid";

BOOST_INLINE_CONSTEXPR char* overflow			=	"overflow";
BOOST_INLINE_CONSTEXPR char* underflow			=	"underflow";

BOOST_INLINE_CONSTEXPR char* half_even			=	"half_even";
BOOST_INLINE_CONSTEXPR char* half_odd			=	"half_odd";
BOOST_INLINE_CONSTEXPR char* half_pos_inf		=	"half_pos_inf";
BOOST_INLINE_CONSTEXPR char* half_neg_inf		=	"half_neg_inf";
BOOST_INLINE_CONSTEXPR char* half_zero			=	"half_zero";

BOOST_INLINE_CONSTEXPR char* all				=	"all";
BOOST_INLINE_CONSTEXPR char* divbyzero			=	"div_by_zero";

BOOST_INLINE_CONSTEXPR char* one				=	"one";
BOOST_INLINE_CONSTEXPR char* half				=	"half";
BOOST_INLINE_CONSTEXPR char* zero				=	"zero";

BOOST_INLINE_CONSTEXPR char* error				=	"error";
BOOST_INLINE_CONSTEXPR char* mistake			=	"mistake";
BOOST_INLINE_CONSTEXPR char* success			=	"success";

BOOST_INLINE_CONSTEXPR char* bin				=	"bin";
BOOST_INLINE_CONSTEXPR char* oct				=	"oct";
BOOST_INLINE_CONSTEXPR char* dec				=	"dec";
BOOST_INLINE_CONSTEXPR char* hex				=	"hex";

BOOST_INLINE_CONSTEXPR char* literal_bin		=	"0b";
BOOST_INLINE_CONSTEXPR char* literal_oct		=	"0o";
BOOST_INLINE_CONSTEXPR char* literal_dec		=	"0d";
BOOST_INLINE_CONSTEXPR char* literal_hex		=	"0x";

BOOST_INLINE_CONSTEXPR char* fixed				=	"fixed";
BOOST_INLINE_CONSTEXPR char* literal			=	"literal";
BOOST_INLINE_CONSTEXPR char* scientific			=	"scientific";
BOOST_INLINE_CONSTEXPR char* alphanumeric		=	"alphanumeric";
BOOST_INLINE_CONSTEXPR char* numeric			=	"numeric";

BOOST_INLINE_CONSTEXPR char* same				=	"same";
BOOST_INLINE_CONSTEXPR char* lower				=	"lower";
BOOST_INLINE_CONSTEXPR char* upper				=	"upper";

BOOST_INLINE_CONSTEXPR char* format				=	"format";
}	//	constants
}	//	strings
}	//	boost

#endif	//	BOOST_STRING_CONSTANTS_HPP
