#ifndef BOOST_TYPE_TRAITS_CONDITIONAL_SIGNED_HPP_INCLUDED
#define BOOST_TYPE_TRAITS_CONDITIONAL_SIGNED_HPP_INCLUDED

#include <boost/type_traits/make_unsigned.hpp>
#include <boost/type_traits/make_signed.hpp>
#include <boost/type_traits/conditional.hpp>

namespace boost
{
template <bool Signed, typename To> struct conditional_signed : public boost::conditional
<
	Signed,
	typename boost::make_signed<To>::type,
	typename boost::make_unsigned<To>::type
>	{};

#if !defined(BOOST_NO_CXX11_TEMPLATE_ALIASES)
template <bool Signed, typename To> using conditional_signed_t = typename boost::conditional_signed<Signed, To>::type;
#endif
}	//	boost

#endif	//	BOOST_TYPE_TRAITS_CONDITIONAL_SIGNED_HPP_INCLUDED
