#ifndef BOOST_TYPE_TRAITS_HAS_VALUE_TYPE_HPP
#define BOOST_TYPE_TRAITS_HAS_VALUE_TYPE_HPP

#include <boost/type_traits/detail/has_type_helper.hpp>

namespace boost
{
namespace detail
{
template <typename T, typename Enable = void>
struct has_value_type_impl : public boost::false_type{};

template <typename T>
struct has_value_type_impl<T, typename has_type_helper<typename T::value_type>::type> : public boost::true_type{};
}	//	detail

template <typename T> struct has_value_type : public boost::integral_constant
<
	bool,
	boost::detail::has_value_type_impl<T>::value
>	{};
template <typename T> struct has_value_type<const T>			: public boost::has_value_type<T>{};
template <typename T> struct has_value_type<volatile const T>	: public boost::has_value_type<T>{};
template <typename T> struct has_value_type<volatile T>			: public boost::has_value_type<T>{};

#if !defined(BOOST_NO_CXX17_INLINE_VARIABLES)
template <typename T> BOOST_INLINE_CONSTEXPR bool has_value_type_v = boost::has_value_type<T>::value;
#endif

#if defined(__cpp_concepts)
namespace meta
{
template <typename T> concept value_type = boost::has_value_type<T>::value;
}	//	meta
#endif
}	//	boost

#endif	//	BOOST_TYPE_TRAITS_HAS_VALUE_TYPE_HPP
