#ifndef BOOST_TYPE_TRAITS_IS_DECIMAL_HPP_INCLUDED
#define BOOST_TYPE_TRAITS_IS_DECIMAL_HPP_INCLUDED

#include <boost/type_traits/integral_constant.hpp>
#include <limits>

namespace boost
{
template <typename T> struct is_decimal : public boost::integral_constant
<
	bool,
	std::numeric_limits<T>::radix == 10
>	{};
template <typename T> struct is_decimal<const T>			: public boost::is_decimal<T>{};
template <typename T> struct is_decimal<volatile const T>	: public boost::is_decimal<T>{};
template <typename T> struct is_decimal<volatile T>			: public boost::is_decimal<T>{};

#if !defined(BOOST_NO_CXX17_INLINE_VARIABLES)
template <typename T> BOOST_INLINE_CONSTEXPR bool is_decimal_v = boost::is_decimal<T>::value;
#endif

#if defined(__cpp_concepts)
namespace meta
{
template <typename T> concept decimal = boost::is_decimal<T>::value;
}	//	meta
#endif
}	//	boost

#endif	//	BOOST_TYPE_TRAITS_IS_DECIMAL_HPP_INCLUDED
