#ifndef BOOST_TYPE_TRAITS_IS_LOGIC_HPP_INCLUDED
#define BOOST_TYPE_TRAITS_IS_LOGIC_HPP_INCLUDED

#include <boost/type_traits/integral_constant.hpp>

namespace boost
{
template <typename T> struct is_logic					: public boost::false_type{};
template <typename T> struct is_logic<const T>			: public boost::is_logic<T>{};
template <typename T> struct is_logic<volatile const T>	: public boost::is_logic<T>{};
template <typename T> struct is_logic<volatile T>		: public boost::is_logic<T>{};

template<> struct is_logic<bool>	: public boost::true_type{};

// move to logic/tribool.hpp
//template<> struct is_logic<tribool>	: public boost::true_type{};

#if !defined(BOOST_NO_CXX17_INLINE_VARIABLES)
template <typename T> BOOST_INLINE_CONSTEXPR bool is_logic_v = boost::is_logic<T>::value;
#endif

#if defined(__cpp_concepts)
namespace meta
{
template <typename T> concept logic = boost::is_logic<T>::value;
}	//	meta
#endif
}	//	boost

#endif	//	BOOST_TYPE_TRAITS_IS_LOGIC_HPP_INCLUDED
