#ifndef BOOST_TYPE_TRAITS_IS_RATIONAL_HPP_INCLUDED
#define BOOST_TYPE_TRAITS_IS_RATIONAL_HPP_INCLUDED

#include <boost/type_traits/integral_constant.hpp>

namespace boost
{
template <typename T> struct is_rational 					: public boost::false_type{};
template <typename T> struct is_rational<const T>			: public boost::is_rational<T>{};
template <typename T> struct is_rational<volatile const T>	: public boost::is_rational<T>{};
template <typename T> struct is_rational<volatile T>		: public boost::is_rational<T>{};

// move to rational.hpp
//template <typename T>	struct is_rational<boost::rational<T>>	: boost::true_type{};

#if !defined(BOOST_NO_CXX17_INLINE_VARIABLES)
template <typename T> BOOST_INLINE_CONSTEXPR bool is_rational_v = is_rational<T>::value;
#endif

#if defined(__cpp_concepts)
namespace meta
{
template <typename T> concept rational = boost::is_rational<T>::value;
}	//	meta
#endif
}	//	boost

#endif	//	BOOST_TYPE_TRAITS_IS_RATIONAL_HPP_INCLUDED
