#ifndef BOOST_TYPE_TRAITS_IS_SAME_SIGNED_HPP_INCLUDED
#define BOOST_TYPE_TRAITS_IS_SAME_SIGNED_HPP_INCLUDED

#include <boost/type_traits/is_signed.hpp>

namespace boost
{
template <typename T1, typename T2> struct is_same_signed : public boost::integral_constant
<
	bool,
	boost::is_signed<T1>::value == boost::is_signed<T2>::value
>	{};

#if !defined(BOOST_NO_CXX17_INLINE_VARIABLES)
template <typename T1, typename T2> BOOST_INLINE_CONSTEXPR bool is_same_signed_v = boost::is_same_signed<T1, T2>::value;
#endif

#if defined(__cpp_concepts)
namespace meta
{
template <typename T1, typename T2> concept same_signed = boost::is_same_signed<T1, T2>::value;
}	//	meta
#endif
}	//	boost

#endif	//	BOOST_TYPE_TRAITS_IS_SAME_SIGNED_HPP_INCLUDED
