#ifndef BOOST_TYPE_TRAITS_IS_SIGNED_INTEGER_HPP_INCLUDED
#define BOOST_TYPE_TRAITS_IS_SIGNED_INTEGER_HPP_INCLUDED

#include <boost/type_traits/is_integer.hpp>
#include <boost/type_traits/is_signed.hpp>

namespace boost
{
template <typename T> struct is_signed_integer : public boost::integral_constant
<
	bool,
	boost::is_integer<T>::value && boost::is_signed<T>::value
>	{};
template <typename T> struct is_signed_integer<const T>			: public boost::is_signed_integer<T>{};
template <typename T> struct is_signed_integer<volatile const T>: public boost::is_signed_integer<T>{};
template <typename T> struct is_signed_integer<volatile T>		: public boost::is_signed_integer<T>{};

#if !defined(BOOST_NO_CXX17_INLINE_VARIABLES)
template <typename T> BOOST_INLINE_CONSTEXPR bool is_signed_integer_v = boost::is_signed_integer<T>::value;
#endif

#if defined(__cpp_concepts)
namespace meta
{
template <typename T> concept signed_integer = boost::is_signed_integer<T>::value;
}	//	meta
#endif
}	//	boost

#endif	//	BOOST_TYPE_TRAITS_IS_SIGNED_INTEGER_HPP_INCLUDED
