#ifndef BOOST_TYPE_TRAITS_IS_STATIC_STRING_HPP
#define BOOST_TYPE_TRAITS_IS_STATIC_STRING_HPP

#include <boost/type_traits/integral_constant.hpp>
#include <boost/static_string.hpp>

namespace boost
{
template <typename> struct is_static_string : public boost::false_type{};
template <std::size_t Size, typename... Ts> struct is_static_string<boost::static_strings::basic_static_string<Size, Ts...>> : public boost::true_type{};

#if !defined(BOOST_NO_CXX17_INLINE_VARIABLES)
template <typename T> BOOST_INLINE_CONSTEXPR bool is_static_string_v = boost::is_static_string<T>::value;
#endif

#if defined(__cpp_concepts)
namespace meta
{
template <typename T> concept static_static = boost::is_static_string<T>::value;
}	//	meta
#endif
}	//	boost

#endif	//	BOOST_TYPE_TRAITS_IS_STATIC_STRING_HPP
