#ifndef BOOST_TYPE_TRAITS_IS_STRING_CLASS_HPP_INCLUDED
#define BOOST_TYPE_TRAITS_IS_STRING_CLASS_HPP_INCLUDED

#include <boost/type_traits/integral_constant.hpp>
#include <string>

namespace boost
{
template <typename> struct is_string_class : public boost::false_type{};
template <typename... Ts> struct is_string_class<std::basic_string<Ts...>> : public boost::true_type{};

#if !defined(BOOST_NO_CXX17_INLINE_VARIABLES)
template <typename T> BOOST_INLINE_CONSTEXPR bool is_string_class_v = boost::is_string_class<T>::value;
#endif

#if defined(__cpp_concepts)
namespace meta
{
template <typename T> concept string_class = boost::is_string_class<T>::value;
}	//	meta
#endif
}	//	boost

#endif	//	BOOST_TYPE_TRAITS_IS_STRING_CLASS_HPP_INCLUDED
