#ifndef BOOST_TYPE_TRAITS_IS_STRING_REF_HPP_INCLUDED
#define BOOST_TYPE_TRAITS_IS_STRING_REF_HPP_INCLUDED

#include <boost/type_traits/integral_constant.hpp>
#include <boost/utility/string_ref.hpp>

namespace boost
{
template <typename> struct is_string_ref : public boost::false_type{};
template <typename... Ts> struct is_string_ref<boost::basic_string_ref<Ts...>> : public boost::true_type{};

#if !defined(BOOST_NO_CXX17_INLINE_VARIABLES)
template <typename T> BOOST_INLINE_CONSTEXPR bool is_string_ref_v = boost::is_string_ref<T>::value;
#endif

#if defined(__cpp_concepts)
namespace meta
{
template <typename T> concept string_ref = boost::is_string_view<T>::value;
}	//	meta
#endif
}	//	boost

#endif	//	BOOST_TYPE_TRAITS_IS_STRING_REF_HPP_INCLUDED
