#ifndef BOOST_TYPE_TRAITS_IS_STRING_VIEW_HPP_INCLUDED
#define BOOST_TYPE_TRAITS_IS_STRING_VIEW_HPP_INCLUDED

#include <boost/type_traits/integral_constant.hpp>
#include <boost/utility/string_view.hpp>

#if !defined(BOOST_NO_CXX17_HDR_STRING_VIEW)
#include <string_view>
#endif

namespace boost
{
template <typename> struct is_string_view : public boost::false_type{};
template <typename... Ts> struct is_string_view<boost::basic_string_view<Ts...>> : public boost::true_type{};

#if !defined(BOOST_NO_CXX17_HDR_STRING_VIEW)
template <typename... Ts> struct is_string_view<std::basic_string_view<Ts...>> : public boost::true_type{};
#endif

#if !defined(BOOST_NO_CXX17_INLINE_VARIABLES)
template <typename T> BOOST_INLINE_CONSTEXPR bool is_string_view_v = boost::is_string_view<T>::value;
#endif

#if defined(__cpp_concepts)
namespace meta
{
template <typename T> concept string_view = boost::is_string_view<T>::value;
}	//	meta
#endif
}	//	boost

#endif	//	BOOST_TYPE_TRAITS_IS_STRING_VIEW_HPP_INCLUDED
