#ifndef BOOST_TYPE_TRAITS_IS_UNSIGNED_CHARACTER_HPP_INCLUDED
#define BOOST_TYPE_TRAITS_IS_UNSIGNED_CHARACTER_HPP_INCLUDED

#include <boost/type_traits/is_character.hpp>
#include <boost/type_traits/is_unsigned_char8.hpp>

namespace boost
{
template <typename T> struct is_unsigned_character : public boost::integral_constant
<
	bool,
	boost::is_character<T>::value && boost::is_unsigned<T>::value
>	{};
template <typename T> struct is_unsigned_character<const T>			: public boost::is_unsigned_character<T>{};
template <typename T> struct is_unsigned_character<volatile const T>: public boost::is_unsigned_character<T>{};
template <typename T> struct is_unsigned_character<volatile T>		: public boost::is_unsigned_character<T>{};

#if !defined(BOOST_NO_CXX17_INLINE_VARIABLES)
template <typename T> BOOST_INLINE_CONSTEXPR bool is_unsigned_character_v = boost::is_unsigned_character<T>::value;
#endif

#if defined(__cpp_concepts)
namespace meta
{
template <typename T> concept unsigned_character = boost::is_unsigned_character<T>::value;
}	//	meta
#endif
}	//	boost

#endif	//	BOOST_TYPE_TRAITS_IS_UNSIGNED_CHARACTER_HPP_INCLUDED
