#ifndef BOOST_TYPE_TRAITS_MAKE_SAME_SIGNED_HPP_INCLUDED
#define BOOST_TYPE_TRAITS_MAKE_SAME_SIGNED_HPP_INCLUDED

#include <boost/type_traits/make_unsigned.hpp>
#include <boost/type_traits/make_signed.hpp>
#include <boost/type_traits/is_signed.hpp>
#include <boost/type_traits/conditional.hpp>

namespace boost
{
template <typename From, typename To> struct make_same_signed : public boost::conditional
<
	boost::is_signed<From>::value,
	typename boost::make_signed<To>::type,
	typename boost::make_unsigned<To>::type
>	{};

#if !defined(BOOST_NO_CXX11_TEMPLATE_ALIASES)
template <typename From, typename To> using make_same_signed_t = typename boost::make_same_signed<From, To>::type;
#endif
}	//	boost

#endif	//	BOOST_TYPE_TRAITS_MAKE_SAME_SIGNED_HPP_INCLUDED
